function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
var _excluded = ["extra", "children", "list", "fieldNames", "maxCount", "value", "defaultValue", "render", "searchFn", "onSearch", "onChange"];
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(arr, i) { var _i = null == arr ? null : "undefined" != typeof Symbol && arr[Symbol.iterator] || arr["@@iterator"]; if (null != _i) { var _s, _e, _x, _r, _arr = [], _n = !0, _d = !1; try { if (_x = (_i = _i.call(arr)).next, 0 === i) { if (Object(_i) !== _i) return; _n = !1; } else for (; !(_n = (_s = _x.call(_i)).done) && (_arr.push(_s.value), _arr.length !== i); _n = !0); } catch (err) { _d = !0, _e = err; } finally { try { if (!_n && null != _i.return && (_r = _i.return(), Object(_r) !== _r)) return; } finally { if (_d) throw _e; } } return _arr; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
/**
 * @author 施阳 2020-08-05
 * 以下API为在Select组件原有API基础上扩展出的API，方便结合业务使用
 * @param {object[]} list 下拉选项列表；
 * @param {number} maxCount 多选时最大显示个数，超出toast提示；
 * @param {string} extra 额外项，针对下拉选项中“请选择”、“不限”这种无实际意义的下拉选项；
 * @param {function} searchFn 普通查询方法
 * @param {object} fieldNames 别名
 */
import React, { useContext, useEffect, useState } from 'react';
import { Select, Spin, message } from 'antd';
import { isObject, isArray } from "../_util";
import { useConfig } from "../_util/hooks";
import { useUpdateEffect } from 'ahooks';
import { ConfigContext } from "../config-provider/context";
import { replaceMessage } from "../locale/utils";
var Option = Select.Option;
var FIELD_NAMES = {
  id: 'id',
  name: 'name'
}; // 别名
var EXTRA_VALUE = ''; // 额外项的默认id

var RefSelect = function RefSelect(props) {
  var componentContext = useContext(ConfigContext);
  var uiLocale = componentContext.uiLocale;
  var extra = props.extra,
    children = props.children,
    list = props.list,
    fieldNames = props.fieldNames,
    maxCount = props.maxCount,
    value = props.value,
    defaultValue = props.defaultValue,
    render = props.render,
    searchFn = props.searchFn,
    onSearch = props.onSearch,
    onChange = props.onChange,
    rest = _objectWithoutProperties(props, _excluded);
  var alias = _objectSpread(_objectSpread({}, FIELD_NAMES), fieldNames); // 别名
  var _useState = useState(value || defaultValue),
    _useState2 = _slicedToArray(_useState, 2),
    currValue = _useState2[0],
    setCurrValue = _useState2[1];
  var _useState3 = useState(list || []),
    _useState4 = _slicedToArray(_useState3, 2),
    optionList = _useState4[0],
    setOptionList = _useState4[1];
  var _useState5 = useState(false),
    _useState6 = _slicedToArray(_useState5, 2),
    loading = _useState6[0],
    setLoading = _useState6[1];
  useUpdateEffect(function () {
    setCurrValue(value);
  }, [value]);
  useUpdateEffect(function () {
    setOptionList(list || []);
  }, [list]);

  // 获取下拉列表
  useEffect(function () {
    if (!searchFn) return;
    setLoading(true);
    searchFn().then(function (data) {
      if (!data) return;
      setOptionList(data);
    }).finally(function () {
      return setLoading(false);
    });
    // eslint-disable-next-line react-hooks/exhaustive-deps
  }, []);
  var _onChange = function _onChange(value, option) {
    var _isArray = isArray(value);

    // 校验最大长度
    if (maxCount && _isArray && value.length > maxCount) {
      message.warning(replaceMessage(uiLocale.Select.countWarning, {
        count: "".concat(maxCount)
      }));
      return;
    }

    // 提取选中项
    var item = (optionList || []).filter(function (item) {
      return _isArray ? value.includes(item[alias.id]) : isObject(value) ? item[alias.id] === value.value : item[alias.id] === value;
    });
    setCurrValue(value);
    onChange && onChange(value, option, _isArray ? item : item[0]);
  };
  return useConfig( /*#__PURE__*/React.createElement(Select, _extends({
    placeholder: uiLocale.global.placeholder,
    loading: loading,
    notFoundContent: loading ? /*#__PURE__*/React.createElement(Spin, {
      size: "small"
    }) : uiLocale.Empty.description,
    getPopupContainer: function getPopupContainer(triggerNode) {
      return triggerNode.parentNode ? triggerNode.parentNode : document.body;
    }
  }, rest, {
    style: _objectSpread({
      width: '100%'
    }, rest.style || {}),
    value: currValue,
    onChange: _onChange
  }), extra && /*#__PURE__*/React.createElement(Option, {
    value: EXTRA_VALUE,
    key: extra
  }, extra), children ? children : render ? render(optionList) : optionList.map(function (item) {
    return /*#__PURE__*/React.createElement(Option, {
      key: item[alias.id],
      value: item[alias.id],
      title: item[alias.name]
    }, item[alias.name]);
  })));
};
RefSelect.Option = Option;
export default RefSelect;